import { RestApiRequest, RestApiRoute, RestPathParams, RestQueryParams, RestRequestBody, RestRequestHeaders, RestRequireAuthentication, RestResponseBody } from './types';
import { RequiredOnly } from './types/RequiredOnly';
type AuthenticationHeaders<RequireAuthentication extends RestRequireAuthentication> = RequireAuthentication extends true ? {
    Authentication: `Bearer ${string}`;
} : never;
export declare function fetchRestApi<PathParams extends RestPathParams, QueryParams extends RestQueryParams, RequestHeaders extends RestRequestHeaders, RequestBody extends RestRequestBody, ResponseBody extends RestResponseBody, RequireAuthentication extends RestRequireAuthentication>(restApiUrl: string, route: RestApiRoute<PathParams, QueryParams, RequestHeaders, RequestBody, ResponseBody, RequireAuthentication>, request: RequiredOnly<RestApiRequest<PathParams, QueryParams, RequestHeaders & AuthenticationHeaders<RequireAuthentication>, RequestBody, RequireAuthentication>>): Promise<ResponseBody>;
export {};
