import { RestPathParams, RestQueryParams, RestRequestBody } from './index';
import { RestRequestHeaders } from './RestRequestHeaders';
import { RestRequireAuthentication } from './RestRequireAuthentication';
import { RequiredOnly } from './RequiredOnly';
export type RestApiRequest<PathParams extends RestPathParams = never, QueryParams extends RestQueryParams = never, RequestHeaders extends RestRequestHeaders = never, RequestBody extends RestRequestBody = never, RequireAuthentication extends RestRequireAuthentication = false> = RequiredOnly<{
    pathParams: PathParams;
    queryParams: QueryParams;
    headers: RequestHeaders;
    body: RequestBody;
    userId: RequireAuthentication extends true ? string : never;
}>;
export type RestApiRequestBase = RestApiRequest<any, any, any, any, true | never>;
